#!/usr/bin/perl -w
#
# Make VDRs mark-datei
# makeMarks.pl by Christoph Heuel <mail@christoph-heuel.net>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# Or, point your browser to http://www.gnu.org/copyleft/gpl.html
#
# $Id: makeMarks.pl,v 1.2 2005/01/17 21:55:06 ch Exp $
#
#
use DateTime;

my $logdb = "./log.db";

if ( !defined( $ARGV[0] ) ) {
	print "No Argument applied!\n";
	exit 1;
}
elsif ( !-d $ARGV[0] ) {
	print "Supplied VDR-Directory \"" . $ARGV[0] . "\" does not exist!\n";
	exit 2;
}

my $vdrdir = $ARGV[0];

# m/^.*(\d+\.\d+\.\d+\.\d+\.\d+)\.rec\/?$/
@starttime =
  $vdrdir =~ m/(\d+)\-(\d+)-(\d+).*(\d+)\.(\d+)\.(\d+)\.(\d+)\.rec\/?$/;
#print $vdrdir. "\n Processing marks...\n";

$dt = DateTime->new(
	year       => $starttime[0],
	month      => $starttime[1],
	day        => $starttime[2],
	hour       => $starttime[3],
	minute     => $starttime[4],
	second     => $starttime[5],
	nanosecond => $starttime[6] * 10000000
);

open( LOG, $logdb );

while (<LOG>) {
#	print $_;
	( $hour, $minute, $second, $Interpret ) =
	  $_ =~ m/.*\((\d{2}):(\d{2}):(\d{2})\).*\{(.*)\}.*\[(.*)\]/;
	my $tmpdt = $dt->clone();
	$tmpdt->set( hour       => $hour );
	$tmpdt->set( minute     => $minute );
	$tmpdt->set( second     => $second );
	$tmpdt->set( nanosecond => 0  );
	$tmp = $tmpdt->subtract_datetime($dt);
	printf("%02u:%02u:%02u:00  %s\n", $tmp->hours, $tmp->minutes, $tmp->seconds, $Interpret);
	
}

