#!/usr/bin/perl -w
#
# vtxdecode.pl by Christoph Heuel <mail@christoph-heuel.net>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# Or, point your browser to http://www.gnu.org/copyleft/gpl.html
#
# $Id: vtxdecode.pl,v 1.2 2005/01/18 12:52:31 ch Exp $
#
sub decodeVTXPageToASCII
{
	my $filename;
	$filename = $_[0];

	$buf = "";
	if ( !-f $filename )
	{
		print "Could not find file $filename \n";
		return "";
	} else
	{
		open( VTXFILE, $filename );
		while (<VTXFILE>)
		{
			$buf .= $_;
		}
		close(VTXFILE);
		my ($newbuf) = "";
		for ( $i = 13 ; $i <= length($buf) ; $i++ )
		{
			$cchar = ord( substr( $buf, $i, $i + 1 ) ) & 0x7F;
			if ( $cchar <= 0x1f )
			{
				$newbuf .= " ";
			} else
			{
				$newbuf .= chr($cchar);
			}
			if ( ( $i - 12 ) % 40 == 0 ) { $newbuf .= "\n"; }
		}
		$newbuf =~ tr/[\x5b\x5c\x5d\x7e\x7b\x7c\x7d]/[]/;
		undef($buf);
		return $newbuf;
	}
}

sub main
{
	$argument = $_[0];
	print decodeVTXPageToASCII($argument);
}
main( $ARGV[0] );
